//+------------------------------------------------------------------+
//|                                                    CCI_Cross.mq4 |
//|                                      Copyright  2006, Eli Hayun |
//|                                          http://www.elihayun.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Eli Hayun"
#property link      "http://www.elihayun.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Lime
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 2
#property indicator_color3 Aqua 
#property indicator_width3 3
#property indicator_color4 Magenta 
#property indicator_width4 3
#property indicator_color5 DodgerBlue
#property indicator_width5 5
#property indicator_color6 Red
#property indicator_width6 5
#property indicator_color7 Lime
#property indicator_width7 5
#property indicator_color8 LightSalmon
#property indicator_width8 5

//---- input parameters
extern int   FastCCI            = 14;
extern bool  UseFCCIArrow       = true;
extern int   fastalertlevel     = 0;
extern int   SlowCCI            = 21;
extern bool  UseSCCIArrow       = false;
extern int   slowalertlevel     = 0;
extern int   VerySlowCCI        = 50;
extern bool  UseVSCCIArrow      = false;
extern int   veryslowalertlevel = 0;
extern bool  Use3CCIArrow       = false;
extern bool  ShowAlert          = false;

//---- buffers

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];

string ShortName ="RK-CCI_Cross";

bool   AlertBuy1  = false;
bool   AlertSell1 = false;
bool   AlertBuy2  = false;
bool   AlertSell2 = false;
bool   AlertBuy3  = false;
bool   AlertSell3 = false;
bool   AlertBuy4  = false;
bool   AlertSell4 = false;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID);
   SetIndexArrow(0,233);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID);
   SetIndexArrow(1,234);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_ARROW,STYLE_SOLID);
   SetIndexArrow(2,111);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,111);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexEmptyValue(3,0.0);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,241);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexEmptyValue(4,0.0);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,242);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexEmptyValue(5,0.0);
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6,67);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexEmptyValue(6,0.0);
   SetIndexStyle(7,DRAW_ARROW);
   SetIndexArrow(7,68);
   SetIndexBuffer(7,ExtMapBuffer8);
   SetIndexEmptyValue(7,0.0);

   SetIndexLabel(0, "FCCI Up");
   SetIndexLabel(1, "FCCI Dw");
   SetIndexLabel(2, "SCCI Up");
   SetIndexLabel(3, "SCCI Dw");
   SetIndexLabel(4, "VSCCI Up");
   SetIndexLabel(5, "VSCCI Dw");
   SetIndexLabel(6, "3CCI Up");
   SetIndexLabel(7, "3CCI Dw");

//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int shift;
   for(shift=Bars-1;shift>=0;shift--)
   {	
      ExtMapBuffer1[shift] = 0; ExtMapBuffer2[shift] = 0; ExtMapBuffer3[shift] = 0; ExtMapBuffer7[shift] = 0;
      ExtMapBuffer4[shift] = 0; ExtMapBuffer5[shift] = 0; ExtMapBuffer6[shift] = 0; ExtMapBuffer8[shift] = 0;

      double fCCI_0 = iCCI(NULL, 0, FastCCI, PRICE_TYPICAL, shift);
      double fCCI_1 = iCCI(NULL, 0, FastCCI, PRICE_TYPICAL, shift+1);
      double fCCI_2 = iCCI(NULL, 0, FastCCI, PRICE_TYPICAL, shift+2);
      double fCCI_3 = iCCI(NULL, 0, FastCCI, PRICE_TYPICAL, shift+3);
      
      if (UseFCCIArrow == true && fCCI_0 > fastalertlevel && fCCI_1 < fastalertlevel && fCCI_2 < fastalertlevel) // && fCCI_3 < fastalertlevel)
        ExtMapBuffer1[shift] = Low[shift] - iATR(NULL,0,20,shift)/2.0; 
   
      if (UseFCCIArrow == true && fCCI_0 < fastalertlevel && fCCI_1 > fastalertlevel && fCCI_2 > fastalertlevel) // && fCCI_3 > fastalertlevel)
        ExtMapBuffer2[shift] = High[shift] + iATR(NULL,0,20,shift)/2.0;

      double sCCI_0 = iCCI(NULL, 0, SlowCCI, PRICE_TYPICAL, shift);
      double sCCI_1 = iCCI(NULL, 0, SlowCCI, PRICE_TYPICAL, shift+1);
      double sCCI_2 = iCCI(NULL, 0, SlowCCI, PRICE_TYPICAL, shift+2);
      
      if (UseSCCIArrow == true && sCCI_0 > slowalertlevel && sCCI_1 < slowalertlevel && sCCI_2 < slowalertlevel)
        ExtMapBuffer3[shift] = Low[shift] - iATR(NULL,0,20,shift)/2.0; 
   
      if (UseSCCIArrow == true && sCCI_0 < slowalertlevel && sCCI_1 > slowalertlevel && sCCI_2 > slowalertlevel)
        ExtMapBuffer4[shift] = High[shift] + iATR(NULL,0,20,shift)/2.0; 

      double vsCCI_0 = iCCI(NULL, 0, VerySlowCCI, PRICE_TYPICAL, shift);
      double vsCCI_1 = iCCI(NULL, 0, VerySlowCCI, PRICE_TYPICAL, shift+1);
      double vsCCI_2 = iCCI(NULL, 0, VerySlowCCI, PRICE_TYPICAL, shift+2);
      
      if (UseVSCCIArrow == true && vsCCI_0 > veryslowalertlevel && vsCCI_1 < veryslowalertlevel && vsCCI_2 < veryslowalertlevel)
        ExtMapBuffer5[shift] = Low[shift] - iATR(NULL,0,20,shift)/2.0; 
   
      if (UseVSCCIArrow == true && vsCCI_0 < veryslowalertlevel && vsCCI_1 > veryslowalertlevel && vsCCI_2 > veryslowalertlevel)
        ExtMapBuffer6[shift] = High[shift] + iATR(NULL,0,20,shift)/2.0; 
        
      if (Use3CCIArrow == true && vsCCI_0 > veryslowalertlevel && vsCCI_1 < veryslowalertlevel && vsCCI_2 < veryslowalertlevel
      && sCCI_0 > slowalertlevel && fCCI_0 > fastalertlevel)
        ExtMapBuffer7[shift] = Low[shift] - iATR(NULL,0,20,shift)/2.0; 
        
      if (Use3CCIArrow == true && vsCCI_0 < veryslowalertlevel && vsCCI_1 > veryslowalertlevel && vsCCI_2 > veryslowalertlevel
      && sCCI_0 < slowalertlevel && fCCI_0 < fastalertlevel)
        ExtMapBuffer8[shift] = High[shift] + iATR(NULL,0,20,shift)/2.0; 
   }

   if(ShowAlert && NewBar()) showAlert();
   return(0);
  }
//+------------------------------------------------------------------+

void showAlert()

{

   if(NewBar()){
      AlertSell1 = false; 
      AlertBuy1  = false;
      AlertSell2 = false; 
      AlertBuy2  = false;
      AlertSell3 = false; 
      AlertBuy3  = false;
      AlertSell4 = false; 
      AlertBuy4  = false;
   }
    int shift;
    for(shift=Bars-1;shift>=0;shift--)
   {	
   
   string sComment = ShortName+" "+Symbol()+"["+getPeriod(Period())+"] "+DoubleToStr(Close[0],Digits);
   if (ExtMapBuffer1[shift] != 0 && AlertBuy1==false){
      sComment = sComment + " CCI("+FastCCI+") UP";
      PlaySound("expert.wav");
      Alert(sComment);
      SendMail ("CCI: ",Symbol()+" "+Period()+": Buy Alert @ "+DoubleToStr(Bid,Digits));
      AlertBuy1  = true;
      AlertSell1 = false;
   }
   if (ExtMapBuffer2[shift] != 0 && AlertSell1==false){
      sComment = sComment + " CCI("+FastCCI+") Down";
      PlaySound("expert.wav");
      Alert(sComment);
      SendMail ("CCI: ",Symbol()+" "+Period()+": Sell Alert @ "+DoubleToStr(Bid,Digits));
      AlertBuy1  = false;
      AlertSell1 = true;
   }
   if (ExtMapBuffer3[shift] != 0 && AlertBuy2==false){
      sComment = sComment + " CCI("+SlowCCI+") UP";
      PlaySound("expert.wav");
      Alert(sComment);
      SendMail ("CCI: ",Symbol()+" "+Period()+": Buy Alert @ "+DoubleToStr(Bid,Digits));
      AlertBuy2  = true;
      AlertSell2 = false;
   }   
   if (ExtMapBuffer4[shift] != 0 && AlertSell2==false){
      sComment = sComment + " CCI("+SlowCCI+") Down";
      PlaySound("expert.wav");
      Alert(sComment);
      SendMail ("CCI: ",Symbol()+" "+Period()+": Sell Alert @ "+DoubleToStr(Bid,Digits));
      AlertBuy2  = false;
      AlertSell2 = true;
   }  
   if (ExtMapBuffer5[shift] != 0 && AlertBuy3==false){
      sComment = sComment + " CCI("+VerySlowCCI+") UP";
      PlaySound("expert.wav");
      Alert(sComment);
      SendMail ("CCI: ",Symbol()+" "+Period()+": Buy Alert @ "+DoubleToStr(Bid,Digits));
      AlertBuy3  = true;
      AlertSell3 = false;
   }   
   if (ExtMapBuffer6[shift] != 0 && AlertSell3==false){
      sComment = sComment + " CCI("+VerySlowCCI+") Down";
      PlaySound("expert.wav");
      Alert(sComment);
      SendMail ("CCI: ",Symbol()+" "+Period()+": Sell Alert @ "+DoubleToStr(Bid,Digits));
      AlertBuy3  = false;
      AlertSell3 = true;
   }
   if (ExtMapBuffer7[shift] != 0 && AlertBuy3==false){
      sComment = sComment + " CCI("+FastCCI+""+SlowCCI+""+VerySlowCCI+") UP";
      PlaySound("expert.wav");
      Alert(sComment);
      SendMail ("CCI: ",Symbol()+" "+Period()+": Buy Alert @ "+DoubleToStr(Bid,Digits));
      AlertBuy4  = true;
      AlertSell4 = false;
   }   
   if (ExtMapBuffer8[shift] != 0 && AlertSell3==false){
      sComment = sComment + " CCI("+FastCCI+""+SlowCCI+""+VerySlowCCI+") Down";
      PlaySound("expert.wav");
      Alert(sComment);
      SendMail ("CCI: ",Symbol()+" "+Period()+": Sell Alert @ "+DoubleToStr(Bid,Digits));
      AlertBuy4  = false;
      AlertSell4 = true;
   }
   
}
}

bool NewBar()
{
   static datetime dt = 0;
   //if (dt == 0) dt = Time[0];
   if (dt != Time[0])
   {
      dt = Time[0];
      return(true);
   }
   return(false);
}


string getPeriod(int period){
   string s="";
   if     (period==1)     s="M1";
   else if(period==5)     s="M5";
   else if(period==15)    s="M15";
   else if(period==30)    s="M30";
   else if(period==60)    s="H1";
   else if(period==240)   s="H4";
   else if(period==1440)  s="D1";
   else if(period==10080) s="W1";
   else if(period==43200) s="MN";
   return(s);
}

